package com.fp.persistence.pgeneral.product;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEPRODUCTRELATIONSHIP*/
@Entity(name="TgeneProductRelationship")
@Table(name="TGENEPRODUCTRELATIONSHIP")
public class TgeneProductRelationship extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneProductRelationship
*/
@EmbeddedId
private TgeneProductRelationshipKey pk;
@Column(name="ISPRINCIPAL", nullable=true)

/**
* Indica si el codigo de relacion es principal, en este caso el codigo de cliente se asocia a la tabla tgeneaccount
*/
private String isprincipal;

/**Contructor por defecto*/
public TgeneProductRelationship(){
}
/**Contructor de TgeneProductRelationship
@param pPk Clave Primaria del entity
*/
public TgeneProductRelationship(TgeneProductRelationshipKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneProductRelationship
*/
public static TgeneProductRelationship find(EntityManager pEntityManager,TgeneProductRelationshipKey pKey) throws Exception{
    TgeneProductRelationship obj = pEntityManager.find(TgeneProductRelationship.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneProductRelationship
@return El objeto que referencia a la Clave primaria de TgeneProductRelationship
*/
public TgeneProductRelationshipKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneProductRelationship
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneProductRelationship
*/
public void setPk(TgeneProductRelationshipKey pPk){
  pk=pPk;
}
/**Obtiene el valor de isprincipal
@return valor de isprincipal*/
public String getIsprincipal(){
  return isprincipal;
}
/**Fija el valor de isprincipal
@param pIsprincipal nuevo Valor de isprincipal*/
public void setIsprincipal(String pIsprincipal){
  isprincipal=pIsprincipal;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneProductRelationship))return false;
    TgeneProductRelationship that = (TgeneProductRelationship) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneProductRelationship
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneProductRelationship
*/
public Object createInstance(){
 TgeneProductRelationship instance=new TgeneProductRelationship();	
 instance.setPk(new TgeneProductRelationshipKey());
 return instance;
}
/**Clona la entidad TgeneProductRelationship
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneProductRelationship p=(TgeneProductRelationship)this.clone();
  p.setPk((TgeneProductRelationshipKey)this.pk.cloneMe());
  return p;
}
}
